Magellan Linux

Diff of /trunk/mage/usr/lib/mage/smage2.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 1571 by niro, Wed Dec 28 10:30:50 2011 UTC revision 1604 by niro, Tue Jan 3 19:11:57 2012 UTC
# Line 10  Line 10 
10  # set default user mage.rc  # set default user mage.rc
11  : ${MAGERC="/etc/mage.rc"}  : ${MAGERC="/etc/mage.rc"}
12    
 ## setup ##  
 PKGSUFFIX="mpk"  
 SRCPKGSUFFIX="mpks"  
 SMAGENAME="$1"  
 SMAGESUFFIX="smage2"  
 MLIBDIR=/usr/lib/mage  
 SMAGEVERSION="$( < ${MLIBDIR}/version)"  
   
 ## only for tests -> normally in /etc/rc.d/init.d/functions  
 COLRED="\033[1;6m\033[31m"  
 COLGREEN="\033[1;6m\033[32m"  
 COLYELLOW="\033[1;6m\033[33m"  
 COLBLUE="\033[1;6m\033[34m"  
 COLMAGENTA="\033[1;6m\033[35m"  
 COLWHITE="\033[1;6m\033[37m"  
 COLGRAY="\033[0;6m\033[37m"  
 COLBOLD="\033[1m"  
 COLDEFAULT="\033[0m"  
   
 if [[ ${NOCOLORS} = true ]]  
 then  
  COLRED=""  
  COLGREEN=""  
  COLYELLOW=""  
  COLBLUE=""  
  COLMAGENTA=""  
  COLWHITE=""  
  COLGRAY=""  
  COLBOLD=""  
  COLDEFAULT=""  
 fi  
   
13  # export default C locale  # export default C locale
14  export LC_ALL=C  export LC_ALL=C
15    
# Line 49  source /etc/mage.rc.global Line 17  source /etc/mage.rc.global
17  source ${MAGERC}  source ${MAGERC}
18  source ${MLIBDIR}/mage4.functions.sh  source ${MLIBDIR}/mage4.functions.sh
19    
20    ## setup ##
21    SMAGENAME="$1"
22    SMAGEVERSION="$(< ${MLIBDIR}/version)"
23    
24  # set PKGDIR and BUILDDIR and BINDIR to MROOT  # set PKGDIR and BUILDDIR and BINDIR to MROOT
25  if [[ -n ${MROOT} ]]  if [[ -n ${MROOT} ]]
26  then  then
# Line 167  get_db_md5_sum() Line 139  get_db_md5_sum()
139    
140  download_sources()  download_sources()
141  {  {
   
142   [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0   [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0
143    
144   local EOA=${#SRC_URI[*]}   local count=${#SRC_URI[*]}
145   local my_SRC_URI   local uri
146   local my_SRC_URI_DEST   local subdir
147   local my_SRC_URI_MIRROR   local outputdir
148   local my_SOURCEDIR   local db_md5_file="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"
149   local DB_MD5_SUM_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"   local fetching
150   local FETCHING   local i
  local i mirror  
  local wget_opts  
   
  # filter wget command if busybox was found  
  wget_opts="$(busybox_filter_wget_options ${WGET_FETCH_OPTIONS})"  
   
  # install SRCDIR/PNAME if not exist  
  [ ! -d ${SOURCEDIR}/${PNAME} ] && install -d ${SOURCEDIR}/${PNAME}  
151    
152   # check if FETCHING is needed   # check if FETCHING is needed
153   ( cd ${SOURCEDIR}/${PNAME}; md5sum -c ${DB_MD5_SUM_FILE} &> /dev/null )   if mchecksum --rundir "${SOURCEDIR}/${PNAME}" --file "${db_md5_file}" --method md5
  if [[ $? = 0 ]]  
154   then   then
155   # md5's ok, no fetching needed   # md5's ok, no fetching needed
156   FETCHING=false   fetching=false
157   else   else
158   FETCHING=true   fetching=true
159   fi   fi
160    
161   for ((i=0; i < EOA; i++))   if [[ ${fetching} = true ]]
162   do   then
163   # url to file   for ((i=0; i < count; i++))
164   my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"   do
165     # url to file
166   # subdir in sources dir; the my_SRCI_URI file goes to there   uri="${SRC_URI[${i}]%%' '*}"
  my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"  
   
  # if my_src_uri_dest is not equal my_src_uri; than an other dir is used  
  if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]  
  then  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}/${my_SRC_URI_DEST}"  
  else  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}"  
  fi  
   
  # create the SOURCEDIR  
  install -d ${my_SOURCEDIR}  
   
  # if an mirrored file than replace first the mirror uri  
  if [[ -n $(echo ${my_SRC_URI} | grep 'mirror://') ]]  
  then  
  for mirror in ${MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|mirror:/|${mirror}/sources|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  ${wget_opts} \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'sourceforge://') ]]  
  then  
  for mirror in ${SOURCEFORGE_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|sourceforge:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  ${wget_opts} \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'gnu://') ]]  
  then  
  for mirror in ${GNU_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|gnu:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  ${wget_opts} \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'kde://') ]]  
  then  
  for mirror in ${KDE_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|kde:/|${mirror}|g")"  
167    
168   if [[ ${FETCHING} = true ]]   # subdir in sources dir; the my_SRCI_URI file goes to there
169   then   subdir="${SRC_URI[${i}]##*' '}"
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  ${wget_opts} \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'gnome://') ]]  
  then  
  for mirror in ${GNOME_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|gnome:/|${mirror}|g")"  
170    
171   if [[ ${FETCHING} = true ]]   # if $subdir is not equal with $uri then an other dir is used
172   then   if [[ ${uri} != ${subdir} ]]
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  ${wget_opts} \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  else  
  if [[ ${FETCHING} = true ]]  
173   then   then
174   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI}${COLDEFAULT}"   outputdir="${SOURCEDIR}/${PNAME}/${subdir}"
175   wget \   else
176   ${wget_opts} \   outputdir="${SOURCEDIR}/${PNAME}"
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI})" \  
  "${my_SRC_URI}"  
177   fi   fi
  fi  
178    
179   # unset them to be shure   echo -e "${COLBLUE}==>${COLGREEN} fetching ${uri}${COLDEFAULT}"
180   unset my_SRC_URI   # do not die here, mchecksum catches download errors
181   unset my_SRC_URI_DEST   mdownload --uri "${uri}" --dir "${outputdir}"
182   unset my_SRC_URI_MIRROR  
183   unset my_SOURCEDIR   # unset them to be sure
184   done   unset uri
185     unset subdir
186     unset outputdir
187     done
188    
189   # recheck md5 sums   # recheck md5 sums after download
190   echo   echo
191   echo -e "${COLBLUE}===${COLGREEN} Checking MD5 sums:${COLDEFAULT}"   echo -e "${COLBLUE}===${COLGREEN} Checking MD5 sums:${COLDEFAULT}"
192   ( cd ${SOURCEDIR}/${PNAME}; md5sum -c ${DB_MD5_SUM_FILE} ) || die "md5 failed"   mchecksum --rundir "${SOURCEDIR}/${PNAME}" --file "${db_md5_file}" --method md5 || die "md5 failed"
193   echo   echo
194     else
195     echo -e "${COLBLUE}===${COLGREEN} All sources already fetched, nothing to do${COLDEFAULT}"
196     fi
197    
198   # not needed anymore   # not needed anymore
199   unset SRC_URI   unset SRC_URI
200  }  }
201    
202  # dummy function, used if that not exist in smage file  # dummy function, used if that does not exist in smage file
203  src_prepare()  src_prepare()
204  {  {
205   echo "no src_prepare defined"   echo "no src_prepare defined; doing nothing ..."
  sleep 2  
206   return 0   return 0
207  }  }
208    
209  # dummy function, used if that not exist in smage file  # dummy function, used if that does not exist in smage file
210  src_compile()  src_compile()
211  {  {
212   echo "no src_compile defined"   echo "no src_compile defined; doing nothing ..."
213   sleep 2   return 0
214    }
215    
216    # dummy function, used if that does not exist in smage file
217    src_check()
218    {
219     echo "no src_check defined; doing nothing ..."
220   return 0   return 0
221  }  }
222    
223  # dummy function, used if that not exist in smage file  # dummy function, used if that does not exist in smage file
224  src_install()  src_install()
225  {  {
226   echo "no src_install defined"   echo "no src_install defined; doing nothing ..."
  sleep 2  
227   return 0   return 0
228  }  }
229    
# Line 490  munpack() Line 344  munpack()
344   rar)   rar)
345   unrar x ${SOURCEDIR}/${PNAME}/${SRCFILE} ${DEST}  || die ".rar unpack failed."   unrar x ${SOURCEDIR}/${PNAME}/${SRCFILE} ${DEST}  || die ".rar unpack failed."
346   ;;   ;;
347   zip|xpi)   zip|xpi|jar)
348   unzip ${SOURCEDIR}/${PNAME}/${SRCFILE} -d ${DEST} || die ".zip unpack failed."   unzip ${SOURCEDIR}/${PNAME}/${SRCFILE} -d ${DEST} || die ".zip unpack failed."
349   ;;   ;;
350   rpm)   rpm)
# Line 556  mautoreconf() Line 410  mautoreconf()
410  minstalldocs()  minstalldocs()
411  {  {
412   local docfiles   local docfiles
413     local doc
414   docfiles="$@"   docfiles="$@"
415    
416   if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]   if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]
# Line 563  minstalldocs() Line 418  minstalldocs()
418   install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."   install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."
419   fi   fi
420    
421   local i   for doc in ${docfiles}
  for i in ${docfiles}  
422   do   do
423   if [ -f ${i} ]   if [ -f ${doc} ]
424   then   then
425   cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."   if mqueryfeature "compressdoc"
426   install -m 0644 ${SRCDIR}/${i}.gz \   then
427   ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."   cat ${doc} | gzip -9c > ${BINDIR}/usr/share/doc/${PNAME}-${PVER}/${doc}.gz || die "gzipping +installing ${doc}."
428     chmod 0644 ${BINDIR}/usr/share/doc/${PNAME}-${PVER}/${doc}.gz || die "fixing permissions of ${doc}."
429     else
430     install -m 0644 ${SRCDIR}/${i} ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "installing ${doc}."
431     fi
432   fi   fi
433   done   done
434  }  }
# Line 579  mstriplibs() Line 437  mstriplibs()
437  {  {
438   local stripdir="$@"   local stripdir="$@"
439    
440   [ -z "${stripdir}" ] && stripdir=${BINDIR}   [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
441   find ${stripdir} | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip ${STRIP_DYN_LIB} 2> /dev/null   [[ -z ${STRIP_DYN_LIB} ]] && STRIP_DYN_LIB="--strip-debug"
442     find ${stripdir} ! -type d | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_DYN_LIB} 2> /dev/null
443  }  }
444    
445  mstripbins()  mstripbins()
446  {  {
447   local stripdir="$@"   local stripdir="$@"
448    
449   [ -z "${stripdir}" ] && stripdir=${BINDIR}   [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
450   find ${stripdir} | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip ${STRIP_DYN_BIN} 2> /dev/null   [[ -z ${STRIP_DYN_BIN} ]] && STRIP_DYN_BIN="--strip-debug"
451     find ${stripdir} ! -type d | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_DYN_BIN} 2> /dev/null
452  }  }
453    
454  mstripstatic()  mstripstatic()
455  {  {
456   local stripdir="$@"   local stripdir="$@"
457    
458   [ -z "${stripdir}" ] && stripdir=${BINDIR}   [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
459   find ${stripdir} | xargs file | grep "ar archive" | cut -f 1 -d : | xargs strip ${STRIP_STATIC_LIB} 2> /dev/null   [[ -z ${STRIP_STATIC_LIB} ]] && STRIP_STATIC_LIB="--strip-debug"
460     find ${stripdir} ! -type d | xargs file | grep "ar archive" | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_STATIC_LIB} 2> /dev/null
461    }
462    
463    mstriplibtoolarchive()
464    {
465     local stripdir="$@"
466    
467     [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
468     find ${stripdir} ! -type d -name \*.la | xargs | grep "libtool library" | cut -f 1 -d : | xargs --no-run-if-empty rm -f -- 2> /dev/null
469    }
470    
471    mpurgetargets()
472    {
473     local stripdir="$@"
474     local target
475    
476     [[ -z ${stripdir} ]] && stripdir=${BINDIR}
477     # nothing to do in this case
478     [[ -z ${PURGE_TARGETS[*]} ]] && return
479    
480     for target in ${PURGE_TARGETS[*]}
481     do
482     # check if target is a regex pattern without any slashes
483     if [[ ${target} = ${target//\/} ]]
484     then
485     find ${BINDIR} -type f -name "${target}" | xargs --no-run-if-empty rm -f -- 2> /dev/null
486     else
487     rm -f -- ${target} 2> /dev/null
488     fi
489     done
490  }  }
491    
492  mcompressdocs()  mcompressdocs()
# Line 655  setup_ccache_environment() Line 545  setup_ccache_environment()
545   fi   fi
546  }  }
547    
   
548  # fixes given dependencies to match a MAGE_TARGET  # fixes given dependencies to match a MAGE_TARGET
549  # fix_mage_deps -target s/depend # <-- note -target !  # fix_mage_deps -target s/depend # <-- note -target !
550  fix_mage_deps()  fix_mage_deps()
# Line 842  regen_mage_tree() Line 731  regen_mage_tree()
731   local subpackage   local subpackage
732    
733   # build them only if requested   # build them only if requested
734   if [[ ${REGEN_MAGE_TREE} = true ]]   if mqueryfeature regentree
735   then   then
736   # run it without targets   # run it without targets
737   if [[ -n ${MAGE_TARGETS} ]]   if [[ -n ${MAGE_TARGETS} ]]
# Line 905  regen_mage_tree() Line 794  regen_mage_tree()
794   unset STATE   unset STATE
795   unset DESCRIPTION   unset DESCRIPTION
796   unset HOMEPAGE   unset HOMEPAGE
797   unset PKGTYPE   # unset PKGTYPE <-- don't do that either; smage needs this var
798   unset INHERITS   unset INHERITS
799   unset DEPEND   unset DEPEND
800   unset SDEPEND   unset SDEPEND
# Line 931  split_save_variables() Line 820  split_save_variables()
820   export SAVED_DEPEND="${DEPEND}"   export SAVED_DEPEND="${DEPEND}"
821   export SAVED_SDEPEND="${SDEPEND}"   export SAVED_SDEPEND="${SDEPEND}"
822   export SAVED_PROVIDE="${PROVIDE}"   export SAVED_PROVIDE="${PROVIDE}"
823   export SAVED_NOPKGBUILD="${NOPKGBUILD}"   export SAVED_PKGTYPE="${PKGTYPE}"
824    
825     # special handling needed for mage features
826     # pkgbuild
827     mqueryfeature "pkgbuild" && export SAVED_FEATURE_PKGBUILD="pkgbuild"
828     mqueryfeature "!pkgbuild" && export SAVED_FEATURE_PKGBUILD="!pkgbuild"
829     # strip
830     mqueryfeature "strip" && export SAVED_FEATURE_STRIP="strip"
831     mqueryfeature "!strip" && export SAVED_FEATURE_STRIP="!strip"
832     # libtool
833     mqueryfeature "libtool" && export SAVED_FEATURE_LIBTOOL="libtool"
834     mqueryfeature "!libtool" && export SAVED_FEATURE_LIBTOOL="!libtool"
835     # compressdoc
836     mqueryfeature "compressdoc" && export SAVED_FEATURE_COMPRESSDOC="compressdoc"
837     mqueryfeature "!compressdoc" && export SAVED_FEATURE_COMPRESSDOC="!compressdoc"
838    
839   # bindir too   # bindir too
840   export SAVED_BINDIR="${BINDIR}"   export SAVED_BINDIR="${BINDIR}"
# Line 992  split_restore_variables() Line 895  split_restore_variables()
895   export DEPEND="${SAVED_DEPEND}"   export DEPEND="${SAVED_DEPEND}"
896   export SDEPEND="${SAVED_SDEPEND}"   export SDEPEND="${SAVED_SDEPEND}"
897   export PROVIDE="${SAVED_PROVIDE}"   export PROVIDE="${SAVED_PROVIDE}"
898   export NOPKGBUILD="${SAVED_NOPKGBUILD}"   export PKGTYPE="${SAVED_PKGTYPE}"
899    
900     # special handling needed for mage features
901     # pkgbuild
902     msetfeature "${SAVED_FEATURE_PKGBUILD}"
903     # strip
904     msetfeature "${SAVED_FEATURE_STRIP}"
905     # libtool
906     msetfeature "${SAVED_FEATURE_LIBTOOL}"
907     # compressdoc
908     msetfeature "${SAVED_FEATURE_COMPRESSDOC}"
909    
910   # bindir too   # bindir too
911   export BINDIR="${SAVED_BINDIR}"   export BINDIR="${SAVED_BINDIR}"
# Line 1052  split_unset_variables() Line 965  split_unset_variables()
965   unset SAVED_SDEPEND   unset SAVED_SDEPEND
966   unset SAVED_PROVIDE   unset SAVED_PROVIDE
967   unset SAVED_BINDIR   unset SAVED_BINDIR
968   unset SAVED_NOPKGBUILD   unset SAVED_PKGTYPE
969     unset SAVED_FEATURE_PKGBUILD
970     unset SAVED_FEATURE_STRIP
971     unset SAVED_FEATURE_LIBTOOL
972     unset SAVED_FEATURE_COMPRESSDOC
973   unset SPLIT_PACKAGE_BASE   unset SPLIT_PACKAGE_BASE
974   unset -f SAVED_preinstall   unset -f SAVED_preinstall
975   unset -f SAVED_postinstall   unset -f SAVED_postinstall
# Line 1152  generate_package_md5sum() Line 1069  generate_package_md5sum()
1069   # fix target as it may be empty !   # fix target as it may be empty !
1070   [ -n "${target}" ] && target="-${target}"   [ -n "${target}" ] && target="-${target}"
1071    
   
1072   # build pkgname   # build pkgname
1073   pkgname="${pname}${target}-${pver}-${parch}-${pbuild}"   pkgname="${pname}${target}-${pver}-${parch}-${pbuild}"
1074    
1075   # build pkg-md5-sum only if requested   # build pkg-md5-sum only if requested
1076   if [[ ${REGEN_MAGE_TREE} = true ]]   if mqueryfeature regentree
1077   then   then
1078   echo -ne "${COLBLUE}===${COLGREEN} generating md5's for ${pkgname}.${PKGSUFFIX} ... ${COLDEFAULT}"   echo -ne "${COLBLUE}===${COLGREEN} generating md5's for ${pkgname}.${PKGSUFFIX} ... ${COLDEFAULT}"
1079    
# Line 1212  source_pkg_build() Line 1128  source_pkg_build()
1128    
1129  step_by_step()  step_by_step()
1130  {  {
1131   if [[ ${STEP_BY_STEP} = true ]]   if mqueryfeature stepbystep
1132   then   then
1133   echo -e "${COLRED}Step-by-step enabled! Paused after $1.${COLDEFAULT}"   echo -e "${COLRED}Step-by-step enabled! Paused after $1.${COLDEFAULT}"
1134   echo "Press [enter] to continue"   echo "Press [enter] to continue"
# Line 1232  then Line 1148  then
1148   exit 1   exit 1
1149  fi  fi
1150    
1151    # load supported mage features
1152    load_mage_features
1153    
1154  # updating smage2-scripts  # updating smage2-scripts
1155  if [[ $1 = update ]]  if [[ $1 = update ]]
1156  then  then
# Line 1416  fi Line 1335  fi
1335  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
1336  then  then
1337   SRCPKGTARBALL="${2}"   SRCPKGTARBALL="${2}"
1338   USE_SRC_PKG_TARBALL=true   msetfeature "srcpkgtarball"
1339    
1340   # abort if given file is not a source pkg   # abort if given file is not a source pkg
1341   [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."   [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
# Line 1460  echo -e "${COLGREEN}Compiling ${PKGNAME} Line 1379  echo -e "${COLGREEN}Compiling ${PKGNAME}
1379  # auto regen mage tree if requested  # auto regen mage tree if requested
1380  regen_mage_tree  regen_mage_tree
1381    
1382  if [[ ${CREATE_SRC_PKG_TARBALL} = true ]]  if mqueryfeature "srcpkg"
1383  then  then
1384   if [[ -d ${SOURCEDIR}/${PNAME} ]]   if [[ -d ${SOURCEDIR}/${PNAME} ]]
1385   then   then
# Line 1470  then Line 1389  then
1389  fi  fi
1390    
1391  # download sources  # download sources
1392  [[ ${USE_SRC_PKG_TARBALL} != true ]] && download_sources  mqueryfeature "srcpkgtarball" || download_sources
1393    
1394  # fixes some issues with these functions  # fixes some issues with these functions
1395  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
1396  export -f src_compile || die "src_compile export failed"  export -f src_compile || die "src_compile export failed"
1397    export -f src_check || die "src_check export failed"
1398  export -f src_install || die "src_install export failed"  export -f src_install || die "src_install export failed"
1399    
1400  # fixes some compile issues  # fixes some compile issues
# Line 1484  export CXXFLAGS="${CFLAGS}" || die "CXXF Line 1404  export CXXFLAGS="${CFLAGS}" || die "CXXF
1404  export BINDIR="${BINDIR}" || die "BINDIR export failed"  export BINDIR="${BINDIR}" || die "BINDIR export failed"
1405  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
1406    
   
1407  # setup distcc  # setup distcc
1408  # setup for distcc goes *before* ccache, so ccache comes before distcc in path  # setup for distcc goes *before* ccache, so ccache comes before distcc in path
1409  [[ ${SMAGE_USE_DISTCC} = true ]] && setup_distcc_environment  mqueryfeature "distcc" && setup_distcc_environment
1410    
1411  # setup ccache  # setup ccache
1412  [[ ${SMAGE_USE_CCACHE} = true ]] && setup_ccache_environment  mqueryfeature "ccache" && setup_ccache_environment
   
 # small sleep to show our settings  
 sleep 1  
1413    
1414  # cleans up build if a previously one exists  # clean up builddir if a previously one exist
1415  if [ -d ${BUILDDIR} ]  if [ -d ${BUILDDIR} ]
1416  then  then
1417   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
1418  fi  fi
1419  install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
1420    
1421  # cleans up srcdir if a previously unpacked one exists  # clean up srcdir if a previously unpacked one exist
1422  if [ -d ${SRCDIR} ]  if [ -d ${SRCDIR} ]
1423  then  then
1424   rm -rf ${SRCDIR}   rm -rf ${SRCDIR}
1425  fi  fi
1426    
1427  # cleans up bindir if a previous build exists or creates a new one  # clean up bindir if a previous build exist or create a new one
1428  if [ -d ${BINDIR} ]  if [ -d ${BINDIR} ]
1429  then  then
1430   rm -rf ${BINDIR}   rm -rf ${BINDIR}
1431  fi  fi
1432  install -d ${BINDIR} || die "couldn't create \$BINDIR."  install -d ${BINDIR} || die "couldn't create \$BINDIR."
1433    
1434  # cleans up package temp dir if a previous build exists  # clean up package temp dir if a previous build exist
1435  if [ -d ${BUILDDIR}/${PKGNAME} ]  if [ -d ${BUILDDIR}/${PKGNAME} ]
1436  then  then
1437   rm -rf ${BUILDDIR}/${PKGNAME}   rm -rf ${BUILDDIR}/${PKGNAME}
1438  fi  fi
1439    
1440  # cleans up timestamp if one exists  # setup build logging
 if [ -f /var/tmp/timestamp ]  
 then  
  mage rmstamp  
 fi  
   
 # setup build loggins  
1441  [[ ! -d /var/log/smage ]] && install -d /var/log/smage  [[ ! -d /var/log/smage ]] && install -d /var/log/smage
1442  echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log  echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log
1443    
1444  src_prepare | ${SMAGE_LOG_CMD}  if [[ ${PKGTYPE} = virtual ]]
 die_pipestatus 0 "src_prepare failed"  
 step_by_step $_  
   
 src_compile | ${SMAGE_LOG_CMD}  
 die_pipestatus 0 "src_compile failed"  
 step_by_step $_  
   
 # build several subpackages  
 if [[ -n ${SPLIT_PACKAGES} ]]  
1445  then  then
1446   # save bindir & pname   echo "virtual package detected; nothing will be build ..."
1447   split_save_variables   # automatically set !pkgbuild here too
1448   export SAVED_BINDIR="${BINDIR}"   msetfeature "!pkgbuild"
  for subpackage in ${SPLIT_PACKAGES}  
  do  
  if typeset -f src_install_${subpackage} > /dev/null  
  then  
  # export subpackage bindir  
  export BINDIR="${SAVED_BINDIR}_${subpackage}"  
  # export PNAME, several internal function and include  
  # rely on this variable  
  export PNAME="${subpackage}"  
   
  echo  
  echo -en "${COLBLUE}*** ${COLDEFAULT}"  
  echo -en "  Running ${COLGREEN}split src_install()${COLDEFAULT}"  
  echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"  
  echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."  
   
  src_install_${subpackage} | ${SMAGE_LOG_CMD}  
  die_pipestatus 0 "src_install_${subpackage} failed"  
  step_by_step $_  
  fi  
  done  
  # restore bindir & pname  
  split_restore_variables  
  # unset all saved smage variables  
  split_unset_variables  
1449  else  else
1450   src_install | ${SMAGE_LOG_CMD}   src_prepare | ${SMAGE_LOG_CMD}
1451   die_pipestatus 0 "src_install failed"   die_pipestatus 0 "src_prepare failed"
1452     step_by_step $_
1453    
1454     src_compile | ${SMAGE_LOG_CMD}
1455     die_pipestatus 0 "src_compile failed"
1456   step_by_step $_   step_by_step $_
1457    
1458     # only run checks if requested
1459     if mqueryfeature "!check"
1460     then
1461     echo "!check detected; src_check() will not be run!" | ${SMAGE_LOG_CMD}
1462     step_by_step src_check
1463     else
1464     src_check | ${SMAGE_LOG_CMD}
1465     die_pipestatus 0 "src_check failed"
1466     step_by_step $_
1467     fi
1468    
1469     # build several subpackages
1470     if [[ -n ${SPLIT_PACKAGES} ]]
1471     then
1472     # save bindir & pname
1473     split_save_variables
1474     export SAVED_BINDIR="${BINDIR}"
1475     for subpackage in ${SPLIT_PACKAGES}
1476     do
1477     if typeset -f src_install_${subpackage} > /dev/null
1478     then
1479     # export subpackage bindir
1480     export BINDIR="${SAVED_BINDIR}_${subpackage}"
1481     # export PNAME, several internal function and include
1482     # rely on this variable
1483     export PNAME="${subpackage}"
1484    
1485     echo
1486     echo -en "${COLBLUE}*** ${COLDEFAULT}"
1487     echo -en "  Running ${COLGREEN}split src_install()${COLDEFAULT}"
1488     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
1489     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
1490    
1491     src_install_${subpackage} | ${SMAGE_LOG_CMD}
1492     die_pipestatus 0 "src_install_${subpackage} failed"
1493     step_by_step $_
1494     fi
1495     done
1496     # restore bindir & pname
1497     split_restore_variables
1498     # unset all saved smage variables
1499     split_unset_variables
1500     else
1501     src_install | ${SMAGE_LOG_CMD}
1502     die_pipestatus 0 "src_install failed"
1503     step_by_step $_
1504     fi
1505  fi  fi
1506    
1507  # compressing doc, info & man files  # echo for sake of good-looking
1508  if [[ -n ${SPLIT_PACKAGES} ]]  echo
1509    
1510    if mqueryfeature "!compressdoc"
1511  then  then
1512   for subpackage in ${SPLIT_PACKAGES}   echo -e "!compressdoc detected; documentation will not be compressed ..."
1513   do  elif mqueryfeature "!pkgbuild"
1514   mcompressdocs ${BINDIR}_${subpackage}  then
1515   done   echo "!pkgbuild detected; skipping documentation compression..."
1516  else  else
1517   mcompressdocs ${BINDIR}   # compressing doc, info & man files
1518     if [[ -n ${SPLIT_PACKAGES} ]]
1519     then
1520     for subpackage in ${SPLIT_PACKAGES}
1521     do
1522     mcompressdocs ${BINDIR}_${subpackage}
1523     done
1524     else
1525     mcompressdocs ${BINDIR}
1526     fi
1527  fi  fi
1528    
1529    if mqueryfeature "!libtool"
1530    then
1531     if mqueryfeature "!pkgbuild"
1532     then
1533     echo "!pkgbuild detected; skipping libtool archive stripping ..."
1534     else
1535     if [[ -n ${SPLIT_PACKAGES} ]]
1536     then
1537     for subpackage in ${SPLIT_PACKAGES}
1538     do
1539     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"
1540     mstriplibtoolarchive ${BINDIR}_${subpackage}
1541     done
1542     else
1543     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"
1544     mstriplibtoolarchive ${BINDIR}
1545     fi
1546     fi
1547    fi
1548    
1549  # stripping all bins and libs  if mqueryfeature "purge"
1550  case ${NOSTRIP} in  then
1551   true|TRUE|yes|y)   if mqueryfeature "!pkgbuild"
1552   echo -e "NOSTRIP=true detected; Package will not be stripped ..."   then
1553   ;;   echo "!pkgbuild detected; skipping file purgation..."
1554   *)   else
1555   if [[ -n ${SPLIT_PACKAGES} ]]   if [[ -n ${SPLIT_PACKAGES} ]]
1556   then   then
1557   for subpackage in ${SPLIT_PACKAGES}   for subpackage in ${SPLIT_PACKAGES}
1558   do   do
1559   echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"   echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"
1560   mstripbins ${BINDIR}_${subpackage}   mpurgetargets ${BINDIR}_${subpackage}
  echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"  
  mstriplibs ${BINDIR}_${subpackage}  
  echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"  
  mstripstatic ${BINDIR}_${subpackage}  
1561   done   done
1562   else   else
1563   echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"   echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"
1564   mstripbins ${BINDIR}   mpurgetargets ${BINDIR}
  echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"  
  mstriplibs ${BINDIR}  
  echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"  
  mstripstatic ${BINDIR}  
1565   fi   fi
1566   ;;   fi
1567  esac  fi
1568    
1569  # the new buildpkg command  # stripping all bins and libs
1570  case ${NOPKGBUILD} in  if mqueryfeature "!strip"
1571   true|TRUE|yes|y)  then
1572   echo -e "NOPGKBUILD=true detected; Package will not be build ..."   echo -e "!strip detected; Package will not be stripped ..."
1573   ;;  elif mqueryfeature "!pkgbuild"
1574   *)  then
1575     echo "!pkgbuild detected; skipping stripping of the package ..."
1576    else
1577     if [[ -n ${SPLIT_PACKAGES} ]]
1578     then
1579     for subpackage in ${SPLIT_PACKAGES}
1580     do
1581     echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
1582     mstripbins ${BINDIR}_${subpackage}
1583     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"
1584     mstriplibs ${BINDIR}_${subpackage}
1585     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"
1586     mstripstatic ${BINDIR}_${subpackage}
1587     done
1588     else
1589     echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
1590     mstripbins ${BINDIR}
1591     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"
1592     mstriplibs ${BINDIR}
1593     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
1594     mstripstatic ${BINDIR}
1595     fi
1596    fi
1597    
1598    if mqueryfeature "!pkgbuild"
1599    then
1600     echo -e "!pkgbuild detected; Package will not be build ..."
1601    else
1602   # build several targets   # build several targets
1603   if [[ -n ${MAGE_TARGETS} ]]   if [[ -n ${MAGE_TARGETS} ]]
1604   then   then
1605   for target in ${MAGE_TARGETS}   for target in ${MAGE_TARGETS}
1606   do   do
1607   # check if an special target_pkgbuild exists   # check if a special target_pkgbuild exists
1608   if typeset -f ${target}_pkgbuild > /dev/null   if typeset -f ${target}_pkgbuild > /dev/null
1609   then   then
1610   # run it   # run it
# Line 1660  case ${NOPKGBUILD} in Line 1637  case ${NOPKGBUILD} in
1637   export PNAME="${subpackage}"   export PNAME="${subpackage}"
1638   split_info_${PNAME}   split_info_${PNAME}
1639    
1640   # jump to next one if NOPKGBUILD is set in split_info   # jump to next one if !pkgbuild is set in split_info
1641   case ${NOPKGBUILD} in   mqueryfeature "!pkgbuild" && continue
  true|TRUE|yes|y) continue ;;  
  esac  
1642    
1643   # check if an special subpackage_pkgbuild exists   # check if an special subpackage_pkgbuild exists
1644   if typeset -f ${PNAME}_pkgbuild > /dev/null   if typeset -f ${PNAME}_pkgbuild > /dev/null
# Line 1707  case ${NOPKGBUILD} in Line 1682  case ${NOPKGBUILD} in
1682   fi   fi
1683    
1684   # build src-pkg-tarball if requested   # build src-pkg-tarball if requested
1685   [[ ${CREATE_SRC_PKG_TARBALL} = true ]] && source_pkg_build ${SMAGENAME}   mqueryfeature "srcpkg" && source_pkg_build ${SMAGENAME}
1686   ;;  fi
 esac  
1687    
1688  if [[ ${SMAGE_BUILD_LOGGING} != false ]]  if mqueryfeature "buildlog"
1689  then  then
1690   bzip2 -9f /var/log/smage/${PKGNAME}.log   bzip2 -9f /var/log/smage/${PKGNAME}.log
1691  else  else
1692   [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log   [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log
1693  fi  fi
1694    
 # for sure  
 unset NOPKGBUILD  
 unset NOSTRIP  
   
1695  xtitleclean  xtitleclean

Legend:
Removed from v.1571  
changed lines
  Added in v.1604